/*
BotV2

Bot API v2

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package botapiv2

import (
	"encoding/json"
)

// checks if the Message type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &Message{}

// Message struct for Message
type Message struct {
	Unified *MessageData `json:"unified,omitempty"`
	// Map of custom message configurations per messenger type
	MessengerCustom *map[string]MessageData `json:"messenger_custom,omitempty"`
	CostOptimized *bool `json:"cost_optimized,omitempty"`
	TemplateRequested *bool `json:"template_requested,omitempty"`
}

// NewMessage instantiates a new Message object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewMessage() *Message {
	this := Message{}
	return &this
}

// NewMessageWithDefaults instantiates a new Message object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewMessageWithDefaults() *Message {
	this := Message{}
	return &this
}

// GetUnified returns the Unified field value if set, zero value otherwise.
func (o *Message) GetUnified() MessageData {
	if o == nil || IsNil(o.Unified) {
		var ret MessageData
		return ret
	}
	return *o.Unified
}

// GetUnifiedOk returns a tuple with the Unified field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Message) GetUnifiedOk() (*MessageData, bool) {
	if o == nil || IsNil(o.Unified) {
		return nil, false
	}
	return o.Unified, true
}

// HasUnified returns a boolean if a field has been set.
func (o *Message) HasUnified() bool {
	if o != nil && !IsNil(o.Unified) {
		return true
	}

	return false
}

// SetUnified gets a reference to the given MessageData and assigns it to the Unified field.
func (o *Message) SetUnified(v MessageData) {
	o.Unified = &v
}

// GetMessengerCustom returns the MessengerCustom field value if set, zero value otherwise.
func (o *Message) GetMessengerCustom() map[string]MessageData {
	if o == nil || IsNil(o.MessengerCustom) {
		var ret map[string]MessageData
		return ret
	}
	return *o.MessengerCustom
}

// GetMessengerCustomOk returns a tuple with the MessengerCustom field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Message) GetMessengerCustomOk() (*map[string]MessageData, bool) {
	if o == nil || IsNil(o.MessengerCustom) {
		return nil, false
	}
	return o.MessengerCustom, true
}

// HasMessengerCustom returns a boolean if a field has been set.
func (o *Message) HasMessengerCustom() bool {
	if o != nil && !IsNil(o.MessengerCustom) {
		return true
	}

	return false
}

// SetMessengerCustom gets a reference to the given map[string]MessageData and assigns it to the MessengerCustom field.
func (o *Message) SetMessengerCustom(v map[string]MessageData) {
	o.MessengerCustom = &v
}

// GetCostOptimized returns the CostOptimized field value if set, zero value otherwise.
func (o *Message) GetCostOptimized() bool {
	if o == nil || IsNil(o.CostOptimized) {
		var ret bool
		return ret
	}
	return *o.CostOptimized
}

// GetCostOptimizedOk returns a tuple with the CostOptimized field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Message) GetCostOptimizedOk() (*bool, bool) {
	if o == nil || IsNil(o.CostOptimized) {
		return nil, false
	}
	return o.CostOptimized, true
}

// HasCostOptimized returns a boolean if a field has been set.
func (o *Message) HasCostOptimized() bool {
	if o != nil && !IsNil(o.CostOptimized) {
		return true
	}

	return false
}

// SetCostOptimized gets a reference to the given bool and assigns it to the CostOptimized field.
func (o *Message) SetCostOptimized(v bool) {
	o.CostOptimized = &v
}

// GetTemplateRequested returns the TemplateRequested field value if set, zero value otherwise.
func (o *Message) GetTemplateRequested() bool {
	if o == nil || IsNil(o.TemplateRequested) {
		var ret bool
		return ret
	}
	return *o.TemplateRequested
}

// GetTemplateRequestedOk returns a tuple with the TemplateRequested field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Message) GetTemplateRequestedOk() (*bool, bool) {
	if o == nil || IsNil(o.TemplateRequested) {
		return nil, false
	}
	return o.TemplateRequested, true
}

// HasTemplateRequested returns a boolean if a field has been set.
func (o *Message) HasTemplateRequested() bool {
	if o != nil && !IsNil(o.TemplateRequested) {
		return true
	}

	return false
}

// SetTemplateRequested gets a reference to the given bool and assigns it to the TemplateRequested field.
func (o *Message) SetTemplateRequested(v bool) {
	o.TemplateRequested = &v
}

func (o Message) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o Message) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Unified) {
		toSerialize["unified"] = o.Unified
	}
	if !IsNil(o.MessengerCustom) {
		toSerialize["messenger_custom"] = o.MessengerCustom
	}
	if !IsNil(o.CostOptimized) {
		toSerialize["cost_optimized"] = o.CostOptimized
	}
	if !IsNil(o.TemplateRequested) {
		toSerialize["template_requested"] = o.TemplateRequested
	}
	return toSerialize, nil
}

type NullableMessage struct {
	value *Message
	isSet bool
}

func (v NullableMessage) Get() *Message {
	return v.value
}

func (v *NullableMessage) Set(val *Message) {
	v.value = val
	v.isSet = true
}

func (v NullableMessage) IsSet() bool {
	return v.isSet
}

func (v *NullableMessage) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMessage(val *Message) *NullableMessage {
	return &NullableMessage{value: val, isSet: true}
}

func (v NullableMessage) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMessage) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


